//===============================================================
// vbtncmd.xxx - button Cmd
//
// Copyright (C) 1995,1996  Bruce E. Wampler
//
// This file is part of the V C++ GUI Framework, and is covered
// under the terms of the GNU Library General Public License,
// Version 2. This library has NO WARRANTY. See the source file
// vapp.cxx for more complete information about license terms.
//===============================================================

#include <v/vxutil.h>	// Motif/Athena mapping
#include <v/vbtncmd.h>	// our definitions
#include <v/vcmdprnt.h>	// a command parent
#include <v/vicon.h>	// for icons
/*
#include <v/vctlclrs.h>
*/

extern "C"
{
/*
#ifdef USE3D
#include <v/awcmd3d.h>
#include <v/awtog3d.h>
#else
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Toggle.h>
#endif

#include <X11/Xaw/Form.h>
*/
}


/*
#ifdef USE3D
#define cmdWidgetClass command3dWidgetClass
#define togWidgetClass toggle3dWidgetClass
#else
#define cmdWidgetClass commandWidgetClass
#define togWidgetClass toggleWidgetClass
#endif
#define Ncallback XtNcallback
#define Nheight XtNheight
#define Nlabel XtNlabel
#define NmappedWhenManaged XtNmappedWhenManaged
#define Nwidth XtNwidth
#define Nresizable(x) XtNresizable,x,
#define setLabel(x,y) char* x = y;
#define freeLabel(x)
*/


//====================>>> vButtonCmd::vButtonCmd <<<=======================
  vButtonCmd::vButtonCmd(vCmdParent* dp, CommandObject* dc) :
    vCmd(dp, dc)
  {
    initialize();
  }

//====================>>> vButtonCmd::~vButtonCmd <<<=======================
  vButtonCmd::~vButtonCmd()
  {

    SysDebug(Destructor,"vButtonCmd::~vButtonCmd() destructor\n")

  }

//=====================>>> vButtonCmd::initialize <<<=======================
  void vButtonCmd::initialize()
  {
    // build a button command for use in a parent window
    GdkPixmap *pixmap = 0;

    CopyToLocal();		// make local copies

    VCONST char* label = _title;

    SysDebug(Constructor,"vButtonCmd::vButtonCmd() constructor\n")

    int map = !(dlgCmd->attrs & CA_Hidden);

    if ((dlgCmd->cmdType == C_IconButton ||
         dlgCmd->cmdType == C_ToggleIconButton) && _itemList != 0)	// icon
      {
	vIcon* ip = (vIcon *) _itemList;	// to access bitmap

	if (dlgCmd->cmdType == C_IconButton)
	    wCmd = gtk_button_new();
	else {
	    wCmd = gtk_toggle_button_new();
	    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(wCmd), _retVal);
	}
	pixmap = ip->GetPixmap(&wCmd->style->bg[GTK_STATE_NORMAL]);
	GtkWidget *wPix = gtk_pixmap_new(pixmap, NULL);
	gtk_widget_show(wPix);
	gtk_container_add(GTK_CONTAINER(wCmd), wPix);
      }
    else if (dlgCmd->cmdType == C_ToggleButton)	// normal toggle button
      {
	wCmd = gtk_toggle_button_new_with_label(label);
	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(wCmd), _retVal);
      }
    else			// regular command button
      {
	wCmd = gtk_button_new_with_label(label);
      }

    if (map) gtk_widget_show(wCmd);

/*
    if (dlgCmd->cmdType == C_Button)
      {
	XtVaSetValues(wCmd,         // the widget to set
            XtNbackground, _vControlFace,
	    NULL);
      }
*/

    if (dlgCmd->cmdType == C_Button && dlgCmd->size > 0) // size - width
      {
	int w = gdk_text_width(wParent->style->font, label, strlen(label));
	if (w < dlgCmd->size)
	  {
	    gtk_widget_set_usize(wCmd, dlgCmd->size, -2);
	  }
/*
	int w = XTextWidth(theApp->_XDefaultFont, label,strlen(label));
	if (w < dlgCmd->size)
	  {
	    XtVaSetValues(wCmd,
#ifdef USE3D
	        Nwidth,dlgCmd->size+3,
#else
	        Nwidth,dlgCmd->size,
#endif
		NULL);	// the border
	  }
*/
      }
    else if (dlgCmd->size > 0)	// size - square (icons, color buttons)
      {
	gtk_widget_set_usize(wCmd, dlgCmd->size, dlgCmd->size);
/*
	XtVaSetValues(wCmd,
#ifdef USE3D
	    Nwidth,dlgCmd->size+3,
	    Nheight, dlgCmd->size+3,
#else
	    Nwidth, dlgCmd->size,
	    Nheight, dlgCmd->size,
#endif
	    NULL);	// the border
*/
      }

    wBox = 0;		// no Box, but make copy for placement

/*
    if ((dlgCmd->attrs & CA_DefaultButton))	// default button?
      {
	// make the Return key work for this button
	XtAccelerators button = XtParseAcceleratorTable(
	    "<Key>Return: set() notify() unset()\n");

	XtVaSetValues(wCmd,
	    XtNaccelerators, button,	// the accelerators
	    NULL);	// the border
      }
*/

    signal_id = gtk_signal_connect(GTK_OBJECT(wCmd), "clicked", 
	GTK_SIGNAL_FUNC(CButtonCmdCB), (gpointer)this);
/*
    XtAddCallback(wCmd, Ncallback, CButtonCmdCB, (XtPointer)this);
*/

/*
    // Need to set to insensitive if it is set insensitive
    if (!_Sensitive)
      {
	XtVaSetValues(wCmd,		// the widget to set
	    XtNsensitive, 0,		// change to insensitive
	    NULL);
      }
*/
    if (!_Sensitive)
	gtk_widget_set_sensitive(wCmd, FALSE);
  }

//==================>>> vButtonCmd::GetCmdValue <<<=========================
  int vButtonCmd::GetCmdValue(ItemVal id) VCONST
  {
    if (id != _cmdId)
	return -1;
    return _retVal;
  }

//================>>> vButtonCmd::ResetItemValue <<<======================
  void vButtonCmd::ResetItemValue(void)
  {

    // We have to toggle things

    if (dlgCmd->cmdType != C_ToggleIconButton &&
	dlgCmd->cmdType != C_ToggleButton)
	return;

    if (_retVal == _origVal)	// No op if no change
	return;

    _retVal = _origVal;		// restore

    gtk_signal_handler_block(GTK_OBJECT(wCmd), signal_id);
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(wCmd), _retVal);
    gtk_signal_handler_unblock(GTK_OBJECT(wCmd), signal_id);
/*
    XtVaSetValues(wCmd, 		// set for this widget
	XtNstate,_retVal,
	NULL);
*/

    // let parent window handle now
    _parentWin->ProcessCmd(_cmdId, _retVal, dlgCmd->cmdType);
  }

//================>>> vButtonCmd::SetCmdVal <<<============================
  void vButtonCmd::SetCmdVal(ItemVal val, ItemSetType st)
  {

    SysDebug1(Misc,"vButtonCmd::SetCmdVal(val:%d)\n",val)

    if (st == Sensitive)
      {
	_Sensitive = val;		// set
	gtk_widget_set_sensitive(wCmd, val);
      }
    else if (st == Hidden)		// hide or unhide
      {
	if (val)
	  {
	    gtk_widget_hide(wCmd);
	  }
	else
	  {
	    gtk_widget_show(wCmd);
	  }
      }
    else if (st == Value || st == Checked)
      {
	_retVal = val;			// set

	gtk_signal_handler_block(GTK_OBJECT(wCmd), signal_id);
	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(wCmd), _retVal);
	gtk_signal_handler_unblock(GTK_OBJECT(wCmd), signal_id);
/*
	XtVaSetValues(wCmd, 		// set for this widget
	  XtNstate,_retVal,
	  NULL);
*/
      }
  }

//================>>> vButtonCmd::SetCmdStr <<<============================
  void vButtonCmd::SetCmdStr(VCONST char* str)
  {
    // Set the string value of button

    SysDebug1(Misc,"vButtonCmd::SetCmdStr(str:%s)\n",str)

    _title = str;

    if (dlgCmd->cmdType == C_Button)
	gtk_label_set(GTK_LABEL(GTK_BIN(wCmd)->child), str);
/*
    setLabel(tmp,str)

    XtVaSetValues(wCmd,		// the widget to set
	Nlabel, tmp, 		// label
	NULL);

    freeLabel(tmp)
*/

  }

//====================>>> vButtonCmd::ButtonCmdCB <<<=======================
  void vButtonCmd::ButtonCmdCB(void)
  {
    if (dlgCmd->cmdType == C_ToggleIconButton || 
	dlgCmd->cmdType == C_ToggleButton)
	_retVal = !_retVal;

    _parentWin->ProcessCmd(_cmdId, _retVal, dlgCmd->cmdType);
  }

extern "C"
{
//============================>>> CButtonCB <<<=============================
  void CButtonCmdCB(GtkButton *button, gpointer This)
  {
    ((vButtonCmd*)This)->ButtonCmdCB();
  }
}
