//===============================================================
// vselfont.cpp - vSelectFont class functions - Windows
//
// Copyright (C) 1995,1996, 1997, 1998  Bruce E. Wampler
//
// This file is part of the V C++ GUI Framework, and is covered
// under the terms of the GNU Library General Public License,
// Version 2. This library has NO WARRANTY. See the source file
// vapp.cxx for more complete information about license terms.
//===============================================================

#include <v/vfontsel.h>           // our header
#include <v/vapp.h>
#include <v/vbasewin.h>

//===================>>> vFontSelect::vFontSelect <<<=======================
  vFontSelect::vFontSelect(vBaseWindow* bw, VCONST char* title) // constructor
  {
/*
     _parentHWND = bw->winHwnd();	// track parent's HWND
*/
     init(title);
  }

//===================>>> vFontSelect::vFontSelect <<<=======================
  vFontSelect::vFontSelect(vApp* aw, VCONST char* title)
  {
/*
     _parentHWND = aw->winHwnd();	// track parent's HWND
*/
     init(title);
  }

//===================>>> vFontSelect::init <<<=======================
  void vFontSelect::init(VCONST char *title)
  {
    _name = NULL;
    _result = 0;
#ifdef GTK_HAVE_FEATURES_1_1_2
    _window = gtk_font_selection_dialog_new(title);
    gtk_signal_connect(
	GTK_OBJECT (GTK_FONT_SELECTION_DIALOG (_window)->ok_button),
	"clicked", GTK_SIGNAL_FUNC(CFontSelCB), (gpointer)this);
    gtk_signal_connect(
	GTK_OBJECT (GTK_FONT_SELECTION_DIALOG (_window)->cancel_button),
	"clicked", GTK_SIGNAL_FUNC(CFontSelCB), (gpointer)this);
#endif
/*
    memset(&_lf,0,sizeof(LOGFONT));	// zap entire thing
    memset(&_cf,0,sizeof(CHOOSEFONT));

    _cf.lStructSize = sizeof(CHOOSEFONT);
    _cf.hwndOwner = _parentHWND;
*/
  }

//======================>>> vFontSelect::SelectFont <<<=======================
  int vFontSelect::FontSelect(vFont& font,const char* msg, int fixedOnly)
  {
    // Select a font
    // @@@ need to add support for fixedOnly

#ifdef GTK_HAVE_FEATURES_1_1_2
    gtk_widget_show(_window);
    if (_name)
	gtk_font_selection_dialog_set_font_name(
	    GTK_FONT_SELECTION_DIALOG (_window), _name);
    gtk_window_set_modal(GTK_WINDOW(_window), TRUE);
    gtk_main();
    if (_result) {
	font.SetGtkFontValues(
	    gtk_font_selection_dialog_get_font(
		GTK_FONT_SELECTION_DIALOG (_window)),
	    _name = gtk_font_selection_dialog_get_font_name(
		GTK_FONT_SELECTION_DIALOG (_window)));
    }
#endif
    return _result;

/*
    // Set to values of the supplied font
    vFontID vfam = font.GetFamily();
    if (vfam == vfOtherFont)
      {
	_cf.rgbColors = font.GetFontColor();
	_lf = font.GetLOGFONT();
      }
    else
      {
	switch (vfam)
	  {
	    case vfSerif:	// Serif font
		_lf.lfPitchAndFamily = DEFAULT_PITCH | FF_ROMAN;
		strcpy(_lf.lfFaceName,"Times New Roman");
		break;

	    case vfSansSerif:	// SansSerif Font
		_lf.lfPitchAndFamily = DEFAULT_PITCH | FF_SWISS;
		strcpy(_lf.lfFaceName,"Arial");
		break;

	    case vfFixed:		// Fixed
		_lf.lfPitchAndFamily = DEFAULT_PITCH | FF_MODERN;
		strcpy(_lf.lfFaceName,"Courier New");
		break;

	    case vfDecorative:	// Decorative
		_lf.lfPitchAndFamily = DEFAULT_PITCH | FF_DECORATIVE;
		strcpy(_lf.lfFaceName,"Wingdings");
		break;

	    default:
                 _lf.lfPitchAndFamily = DEFAULT_PITCH | FF_DONTCARE;
		strcpy(_lf.lfFaceName,"Fixedsys");
		break;
	  }
	 _lf.lfWeight = (font.GetWeight() == vfBold) ? FW_BOLD : FW_REGULAR;
	 _lf.lfHeight = -17;	// Reasonable default
	 _lf.lfItalic = (font.GetStyle() == vfItalic);
	 _lf.lfUnderline = font.GetUnderlined();
      }

    _cf.lpLogFont = &_lf;
    _cf.Flags = CF_SCREENFONTS | CF_EFFECTS |
		CF_INITTOLOGFONTSTRUCT;
    _cf.nFontType = SCREEN_FONTTYPE;

    if (!::ChooseFont(&_cf))
	return 0;

    font.SetWinFontValues(_lf, _cf);

    return 1;
*/
  }

//======================>>> vFontSelect::FontSelCB <<<=======================
  int vFontSelect::FontSelCB(GtkWidget *button)
  {
#ifdef GTK_HAVE_FEATURES_1_1_2
    _result = (button == GTK_FONT_SELECTION_DIALOG (_window)->ok_button);
    gtk_widget_hide(_window);
    gtk_main_quit();
#endif
  }

extern "C"
{
  void CFontSelCB(GtkWidget *button, gpointer This)
  {
    ((vFontSelect*)This)->FontSelCB(button);
  }
}
// ---------------------------------------------------------------------
