//===============================================================
// vframec.cxx	- a frame for holding commands
//
// Copyright (C) 1995,1996  Bruce E. Wampler
//
// This file is part of the V C++ GUI Framework, and is covered
// under the terms of the GNU Library General Public License,
// Version 2. This library has NO WARRANTY. See the source file
// vapp.cxx for more complete information about license terms.
//===============================================================

#include <v/vxutil.h>	// Motif/Athena mapping
#include <v/vapp.h>
#include <v/vframec.h>	// our definitions
#include <v/vcmdprnt.h>	// a command parent
#include <v/gtkvlayout.h>
/*
#include <v/vctlclrs.h>
*/

extern "C"
{
/*
#include <X11/StringDefs.h>

#include <X11/Xaw/Form.h>
*/
}

/*

#define formWidgetC formWidgetClass
#define NborderWidth XtNborderWidth
#define Ncallback XtNcallback
#define Nheight XtNheight
#define Nlabel XtNlabel
#define NmappedWhenManaged XtNmappedWhenManaged
#define Nwidth XtNwidth
#define Nresizable(x) XtNresizable,x,
#define setLabel(x,y) char* x = y;
#define freeLabel(x)

*/


//=====================>>> vFrameCmd::vFrameCmd <<<=======================
  vFrameCmd::vFrameCmd(vCmdParent* dp, CommandObject* dc) :
    vCmd(dp, dc)
  {
    initialize();
  }

//=====================>>> vFrameCmd::~vFrameCmd <<<=======================
  vFrameCmd::~vFrameCmd()
  {

    SysDebug(Destructor,"vFrameCmd::~vFrameCmd() destructor\n")

  }

//=====================>>> vFrameCmd::initialize <<<=======================
  void vFrameCmd::initialize(void)
  {
    // build a button command for use in a parent window


    SysDebug(Constructor,"vFrameCmd::vFrameCmd() constructor\n")

    CopyToLocal();

    int border = (dlgCmd->attrs & CA_NoBorder) ? 0 : 1;    // border?

    int map = !(dlgCmd->attrs & CA_Hidden);

    wCmd = gtk_vlayout_new(dlgCmd->attrs & CA_NoSpace ? 0 : 4);
    gtk_container_border_width(GTK_CONTAINER(wCmd), 
	dlgCmd->attrs & CA_NoSpace ? 0 : 4);
    if (map) gtk_widget_show(wCmd);

    if (border) {
	wBox = gtk_frame_new(NULL);
	if (map) gtk_widget_show(wBox);
	gtk_container_add(GTK_CONTAINER(wBox), wCmd);
    } else
	wBox = 0;
/*
    wBox = XtVaCreateManagedWidget(
	"vFrame",			// name
	formWidgetC,			// class
	wParent,			// parent
	Nresizable(TRUE)
	NmappedWhenManaged, map,
	NborderWidth, border,
	NULL);
*/

/*
    if (dlgCmd->attrs & CA_NoSpace)	// Tight spacing?
      {
	gtk_table_set_row_spacings(GTK_TABLE(wCmd), 0);
	gtk_table_set_col_spacings(GTK_TABLE(wCmd), 0);
	gtk_container_border_width(GTK_CONTAINER(wCmd), 0);
	XtVaSetValues(wBox,		// the widget to set
	    XtNdefaultDistance,0,
	    NULL);
      }
*/
/*
    XtVaSetValues(wBox,         // the widget to set
          XtNbackground, _vDialogBG, NULL);  
*/

//    wCmd = 0;				// wCmd not used
  }

//================>>> vFrameCmd::SetCmdVal <<<============================
  void vFrameCmd::SetCmdVal(ItemVal val, ItemSetType st)
  {

    SysDebug1(Misc,"vFrameCmd::SetCmdVal(val:%d)\n",val)

    if (st == Hidden)		// hide or unhide
      {
	if (val)
	  {
	    gtk_widget_hide(GTK_WIDGET(wBox ? wBox : wCmd));
/*
	    ::XtUnmapWidget(wBox);	// unmap this widget
*/
	  }
	else
	  {
/*
	    ::XtMapWidget(wBox);	// unmap this widget
*/
	    gtk_widget_show(GTK_WIDGET(wBox ? wBox : wCmd));
	  }
      }
    else if (st == Value && dlgCmd->cmdType == C_ToggleFrame)   // Toggle?
      {
	if (val)                // have to hide/show me first
	  {
	    gtk_widget_show(GTK_WIDGET(wBox ? wBox : wCmd));
/*
	    ::XtMapWidget(wBox);	// unmap this widget
*/
	  }
	else
	  {
/*
	    ::XtUnmapWidget(wBox);	// unmap this widget
*/
	    gtk_widget_hide(GTK_WIDGET(wBox ? wBox : wCmd));
	  }
	_parentWin->SetFrameChildren(_cmdId,val); // and now set value of children
      }
 }
