//===============================================================
// vlabelc.cxx	- label Cmd
//
// Copyright (C) 1995,1996  Bruce E. Wampler
//
// This file is part of the V C++ GUI Framework, and is covered
// under the terms of the GNU Library General Public License,
// Version 2. This library has NO WARRANTY. See the source file
// vapp.cxx for more complete information about license terms.
//===============================================================

#include <v/vxutil.h>	// Motif/Athena mapping
#include <v/vlabelc.h>	// our definitions
#include <v/vcmdprnt.h>	// a command parent
#include <v/vicon.h>	// for icons
/*
#include <v/vctlclrs.h>
*/

#undef USE3D		// doesn't work yet...

extern "C"
{

/*
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Form.h>
*/

/*
#ifdef USE3D
#include <v/awlbl3d.h>
#endif
*/
}

/*
#define lblWidgetClass labelWidgetClass
#define NborderWidth XtNborderWidth
#define Ncallback XtNcallback
#define Nheight XtNheight
#define Nlabel XtNlabel
#define NmappedWhenManaged XtNmappedWhenManaged
#define Nwidth XtNwidth
#define Nresizable(x) XtNresizable,x,
#define setLabel(x,y) char* x = y;
#define freeLabel(x)

*/

//=====================>>> vLabelCmd::vLabelCmd <<<=======================
  vLabelCmd::vLabelCmd(vCmdParent* dp, CommandObject* dc):
	    vCmd(dp, dc)
  {
    initialize();
  }

//=====================>>> vLabelCmd::~vLabelCmd <<<=======================
  vLabelCmd::~vLabelCmd()
  {

    SysDebug(Destructor,"vLabelCmd::~vLabelCmd() destructor\n")
  }

//=====================>>> vLabelCmd::initialize <<<=======================
  void vLabelCmd::initialize(void)
  {
    // build a button command for use in a parent window


    SysDebug(Constructor,"vLabelCmd::vLabelCmd() constructor\n")

    CopyToLocal();		// make local copies

    GdkPixmap *pixmap = 0;		// normally, no pixmap

    int map = !(dlgCmd->attrs & CA_Hidden);

    wBox = 0;		// no Box, but make copy for placement

    if (dlgCmd->cmdType == C_Icon && _itemList != 0)	// icon
      {
	vIcon* ip = (vIcon *) _itemList;	// to access bitmap

	pixmap = ip->GetPixmap(&wParent->style->bg[GTK_STATE_NORMAL]);
	wCmd = gtk_pixmap_new(pixmap, NULL);
	if (map) gtk_widget_show(wCmd);

/*
	wCmd = XtVaCreateManagedWidget(
	    "vLabel",		// name
	    lblWidgetClass,	// class
	    wParent,		// parent
	    XtNbitmap, pixmap,	// the pixmap
	    XtNinternalWidth,0,
	    XtNinternalHeight,0,
	    XtNbackground, _vDialogBG,
	    NborderWidth,0,	// label only, no border
	    Nresizable(TRUE)
	    NmappedWhenManaged, map,
	    NULL);
*/

/*
	if (WfVert != 0)
	    XtVaSetValues(wCmd, Nbelow(WfVert) NULL);
	if (WfHoriz != 0)
	    XtVaSetValues(wCmd, NrightOf(WfHoriz) NULL);
*/
      }
    else if (dlgCmd->cmdType == C_Blank)
      {
	// a blank is always unmapped
	wCmd = gtk_label_new("");
	gtk_widget_set_usize(wCmd, 
	    gdk_text_width(GTK_WIDGET (wCmd)->style->font, _title, strlen(_title)),
	    -2);
	//gtk_container_add(GTK_CONTAINER(wParent), wCmd);
	if (map) gtk_widget_show(wCmd);
/*
	setLabel(tmp,_title)

	wCmd = XtVaCreateManagedWidget(
	    "vLabel",			// name
	    lblWidgetClass,		// class
	    wParent,			// parent
	    Nlabel, tmp,		// label
	    NborderWidth,0,		// label only, no border
	    NmappedWhenManaged,FALSE, // just the space!
	    XtNinternalWidth,2,
	    XtNinternalHeight,3,  // adjust to make same height as button
	    Nresizable(TRUE)
	    NULL);
	freeLabel(tmp)
*/
      }
    else if (dlgCmd->cmdType == C_BoxedLabel ||
		dlgCmd->cmdType == C_Text)
      {
	wBox = gtk_frame_new(NULL);
	if (map) gtk_widget_show(wBox);
	if (dlgCmd->cmdType == C_Text && _itemList && *(char*)_itemList)
	    _title = (char *) _itemList;
	wCmd = gtk_label_new(_title);
	gtk_container_add(GTK_CONTAINER(wBox), wCmd);
	gtk_widget_show(wCmd);
      }
    else			// (dlgCmd->cmdType == C_Label)
      {
	wCmd = gtk_label_new(_title);
	if (map) gtk_widget_show(wCmd);
/*
	int borderW = (dlgCmd->cmdType == C_BoxedLabel) ? 1 : 0;
	    
	setLabel(tmp,_title)
#ifdef USE3D
	if (dlgCmd->cmdType == C_BoxedLabel)
	  {
	    wCmd = XtVaCreateManagedWidget(
	        "vLabel",			// name
		label3dWidgetClass,		// class
		wParent,			// parent
		XtNlabel, tmp,		// label
		"shadowWidth",2,	// border width
//		XtNinternalWidth,2,
//		XtNinternalHeight,3,  // adjust to make same height as button
		Nresizable(TRUE)
		NmappedWhenManaged, map,
		NULL);
	    if (WfVert != 0)
		XtVaSetValues(wCmd, Nbelow(WfVert) NULL);
	    if (WfHoriz != 0)
		XtVaSetValues(wCmd, NrightOf(WfHoriz) NULL);
	  }
	else
#endif
	wCmd = XtVaCreateManagedWidget(
	    "vLabel",			// name
	    lblWidgetClass,		// class
	    wParent,			// parent
	    Nlabel, tmp,		// label
	    NborderWidth,borderW,	// border width
	    XtNinternalWidth,2,
	    XtNinternalHeight,3,  // adjust to make same height as button
	    Nresizable(TRUE)
	    NmappedWhenManaged, map,
	    NULL);

	if (WfVert != 0)
	    XtVaSetValues(wCmd, Nbelow(WfVert) NULL);
	if (WfHoriz != 0)
	    XtVaSetValues(wCmd, NrightOf(WfHoriz) NULL);

	freeLabel(tmp)
*/
      }
/*
     XtVaSetValues(wCmd,         // the widget to set
          XtNbackground, _vDialogBG, NULL);
*/


  }

//================>>> vLabelCmd::SetCmdVal <<<============================
  void vLabelCmd::SetCmdVal(ItemVal val, ItemSetType st)
  {

    if (st == Hidden)		// hide or unhide
      {
	if (val)
	  {
	    gtk_widget_hide(wBox ? wBox : wCmd);
/*
	    XtUnmapWidget(wCmd);	// unmap this widget
*/
	  }
	else
	  {
	    gtk_widget_show(wBox ? wBox : wCmd);
/*
	    XtMapWidget(wCmd);	// unmap this widget
*/
	  }
      }
  }

//================>>> vLabelCmd::SetCmdStr <<<============================
  void vLabelCmd::SetCmdStr(VCONST char* str)
  {

    SysDebug1(Misc,"vLabelCmd::SetCmdStr(str:%s)\n",str)

    _title = str;
    gtk_label_set(GTK_LABEL(wCmd), str);
  }
