//===============================================================
// vlistc.cxx	- ListCmd
//
// Copyright (C) 1995,1996  Bruce E. Wampler
//
// This file is part of the V C++ GUI Framework, and is covered
// under the terms of the GNU Library General Public License,
// Version 2. This library has NO WARRANTY. See the source file
// vapp.cxx for more complete information about license terms.
//===============================================================

#include <v/vxutil.h>	// Motif/Athena mapping
#include <v/vlistc.h>	// our definitions
#include <v/vcmdprnt.h>	// a command parent
#include <v/vapp.h>
/*
#include <v/vctlclrs.h>
*/

/*
extern "C"
{
#include <X11/Xlib.h>

#include <X11/Xaw/Form.h>
#ifdef USE3D
#include <v/awscl3d.h>
#define sbWidgetClass scrollbar3dWidgetClass
#define sbThickness 15
#else
#include <X11/Xaw/Scrollbar.h>
#define sbWidgetClass scrollbarWidgetClass
#define sbThickness 10
#endif
#include <X11/Xaw/List.h>

}
*/

#define DefaultWidth 32

/*
#define Nsensitive XtNsensitive
*/

    static char* EmptyItem = "";	// null item for short lists

//=================>>> vListCmd::vListCmd <<<=======================
  vListCmd::vListCmd(vCmdParent* dp, CommandObject* dc) :
	    vCmd(dp, dc)
  {
    // Create bitmaps if need to

/*
    _fscale = 0.0;
    _scale = 0;
*/
    _maxWidth = DefaultWidth;
    initialize();			// and initialize
  }

//=======================>>> vListCmd::~vListCmd <<<=======================
  vListCmd::~vListCmd()
  {

    SysDebug(Constructor,"vListCmd::~vListCmd() Destructor\n")

  }

//=====================>>> vListCmd::initialize <<<=======================
  void vListCmd::initialize(void)
  {

/*
    XtCallbackRec scrollProcList[] =
      {
	{ CScrollProcCB, this },
	{ (XtCallbackProc) 0, (XtPointer) 0}
      };

    XtCallbackRec jumpProcList[] =
      {
	{ CJumpProcCB, this },
	{ (XtCallbackProc) 0, (XtPointer) 0}
      };

    Dimension listHeight;
*/

    SysDebug(Constructor,"vListCmd::vListCmd() constructor\n")

    CopyToLocal();		// make local copies

    // First, setup the list

    _listRows = 8;
    if (dlgCmd->attrs & CA_Size)	// specifying size
      {
	if (dlgCmd->size > 0 && dlgCmd->size <= MAX_LIST)
	    _listRows = dlgCmd->size;
      }

    _workList = 0;
/*
    for (int ix = 0 ; ix < _listRows ; ++ix)
	_workList[ix] = 0;
*/

    SetupList();

    // determine positions

    if (dlgCmd->attrs & CA_ListWidth && dlgCmd->retVal > 0)	// Specifying width
	_maxWidth = dlgCmd->retVal;
    else if (dlgCmd->attrs & CA_Large)
      {
	if (_maxWidth > DefaultWidth)
		_maxWidth = (_maxWidth * 3) / 2;	// 150%
	else
	    _maxWidth = DefaultWidth * 2;
      }

    int map = !(dlgCmd->attrs & CA_Hidden);

    // We will put a box around the list and the scrollbar in Athena
    wBox = gtk_scrolled_window_new(NULL, NULL);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(wBox),
	GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);

    GdkFont *font = GTK_WIDGET(wBox)->style->font;
/*
    gtk_widget_set_usize(GTK_SCROLLED_WINDOW(wBox)->viewport, _maxWidth, 
	_listRows * (font->ascent + font->descent + 2)); /* XXX 
*/

    if (map) gtk_widget_show(wBox);
    wCmd = gtk_list_new();
#ifdef GTK_HAVE_FEATURES_1_1_4
    gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(wBox), wCmd);
#else
    gtk_container_add(GTK_CONTAINER(wBox), wCmd);
#endif
    gtk_widget_set_usize(GTK_BIN(wBox)->child, 
        _maxWidth + 5 + 2 * (GTK_CONTAINER(GTK_BIN(wBox)->child)->border_width +
		GTK_WIDGET(GTK_BIN(wBox)->child)->style->klass->xthickness), 
	_listRows * (font->ascent + font->descent + 2)); /* XXX */

    gtk_widget_show(wCmd);
    gtk_list_append_items(GTK_LIST(wCmd), _workList);
    gtk_list_select_item(GTK_LIST(wCmd), _curSelection);
    gint id = gtk_signal_connect(GTK_OBJECT(wCmd), "selection_changed",
	GTK_SIGNAL_FUNC(CListCmdCB), (gpointer)this);
    if (!_Sensitive)
	gtk_widget_set_sensitive(wBox, FALSE);

/*

    if (dlgCmd->attrs & CA_ListWidth && dlgCmd->retVal > 0)	// Specifying width
	_maxWidth = dlgCmd->retVal;
    else if (dlgCmd->attrs & CA_Large)
      {
	if (_maxWidth > DefaultWidth)
		_maxWidth = (_maxWidth * 3) / 2;	// 150%
	else
	    _maxWidth = DefaultWidth * 2;
      }

    wBox = XtVaCreateManagedWidget(
	"vListFrame",		// name
	formWidgetClass,	// class
	wParent,		// parent
	XtNorientation, XtEhorizontal,
	XtNborderWidth,1,	// border around list and scrollbar
	XtNdefaultDistance, 1,
	XtNresizable, True,
	XtNmappedWhenManaged, map,
	XtNbackground, _vControlFace,
	NULL);

    if (WfVert != 0)
	XtVaSetValues(wBox, Nbelow(WfVert) NULL);
    if (WfHoriz != 0)
	XtVaSetValues(wBox, NrightOf(WfHoriz) NULL);

    wCmd = XtVaCreateManagedWidget(
	"vList",			// name
	listWidgetClass,	// class
	wBox,			// parent
	XtNdefaultColumns, 1,	// 1 column
	XtNforceColumns, True,	// force columns
	XtNlist, _workList,	// the work list
	XtNlongest, _maxWidth,	// widest string
	XtNnumberStrings, _listRows, // _listRows strings
	XtNverticalList, TRUE,	// we are a vertical list
	XtNrowSpacing, 1,
	XtNresizable, True,
	NULL);

    // add callback for action
    XtAddCallback(wCmd, XtNcallback, CListCmdCB, (XtPointer)this);
    
    // Create the scroll bar

    XtVaGetValues(wCmd, XtNheight, &listHeight, NULL);

    Dimension min_thumb = 10;

    _wScroll = XtVaCreateManagedWidget(
	"vListScroll",		// name
	sbWidgetClass,	// class
	wBox,			// parent
	XtNscrollProc, scrollProcList,	// callback for scrolling
	XtNjumpProc, jumpProcList,	// callback for scrolling
	XtNminimumThumb,min_thumb,
	XtNthickness, sbThickness,	// how wide
	XtNlength,listHeight,	// high as list
	XtNfromHoriz, wCmd,
	XtNresizable, TRUE,
#ifdef USE3D
        XtNbackground, _vControlFace, 
        XtNscrollbar3dBackground, _vControlBG,
#endif  
	NULL);

    SetScroll(_ScrlShown, _ScrlTop);



    // Need to set to insensitive if it is set insensitive
    if (!_Sensitive)
      {
	XtVaSetValues(wCmd,		// the widget to set
	    Nsensitive, 0,		// change to insensitive
	    NULL);
	XtVaSetValues(_wScroll,		// the widget to set
	    Nsensitive, 0,		// change to insensitive
	    NULL);
      }
*/

  }

//==================>>> vListCmd::GetCmdValue <<<=========================
  int vListCmd::GetCmdValue(ItemVal id) VCONST
  {
    if (id != _cmdId)
	return -1;
    return _curSelection;
  }

//=====================>>> vListCmd::SetCmdVal <<<=========================
  void vListCmd::SetCmdVal(ItemVal val, ItemSetType st)
  {

    SysDebug2(Misc,"vListCmd::SetCmdVal(val:%d, type:%d)\n",val,st)

    if (st == ChangeList || st == ChangeListPtr)
      {
	if (st == ChangeListPtr)
	    _itemList = dlgCmd->itemList;

	int oldMax = _maxWidth;		// track current max width

	gtk_list_remove_items(GTK_LIST(wCmd), _workList);
	//gtk_list_clear_items(GTK_LIST(wCmd), 0, -1);

	SetupList();			// resetup the list

	gtk_list_append_items(GTK_LIST(wCmd), _workList);

	if (oldMax > _maxWidth)
	    _maxWidth = oldMax;		// don't let it get narrower

/*
	// turn them all off!
	XawListChange(wCmd, _workList, _listRows, _maxWidth, True);
	SetScroll(_ScrlShown, _ScrlTop);
*/
	SetCmdVal(val,Value);
	return;

      }
    else if (st == Hidden)		// hide or unhide
      {
	if (val)
	  {
	    gtk_widget_hide(wBox);
	  }
	else
	  {
	    gtk_widget_show(wBox);
	  }
      }
    else if (st == Value)
      {
	if (val >= _numItems )
	    return;

	if (val < 0)		// unselect
	  {
	    _curSelection = -1;
	    // turn them all off!
/*
	    XawListChange(wCmd, _workList, _listRows, _maxWidth, True);
*/
	    return;
	  }

	// Now set appropriate _curSelection, scroll, and highlight

	_curSelection = val;	// change the current value

	// if the selection is already on the screen, then highlight it
	// See if the currently selected item is on the list, and rehighlight
	gtk_list_select_item(GTK_LIST(wCmd), _curSelection);

/*

	int newSel = _curSelection - _workMapsTo;

	if (newSel >= 0 && newSel < _listRows)
	  {
	    XawListChange(wCmd, _workList, _listRows, _maxWidth, True);
	    XawListHighlight(wCmd, newSel);
	  }
	else			// have to scroll
	  {
	    DoScroll(_curSelection - _workMapsTo);  // change what is displayed
	  }

	// Need to set explicitly if not yet realized
	if (!XtIsRealized(wCmd))
	  {
	    XtVaSetValues(wCmd, 
		XtNlongest, _maxWidth,	// widest string
		NULL);
	  }
*/
      }
    else if (st == Sensitive)
      {
	_Sensitive = val;
	gtk_widget_set_sensitive(wBox, val);
      }
  }

//====================>>> vListCmd::ListCmdCB <<<=======================
  void vListCmd::ListCmdCB(int index)
  {
    _curSelection = index + _workMapsTo;  // change the current selection

    if (_curSelection >= _numItems )
	_curSelection = -1;

    if (!(dlgCmd->attrs & CA_NoNotify))	// Notify on each selection?
	_parentWin->ProcessCmd(_cmdId, _curSelection, dlgCmd->cmdType);
  }

//====================>>> vListCmd::SetupList <<<=======================
  void vListCmd::SetupList(void)
  {
    // Set up the list for use

    int width, len;

    // First, count how many items are in the supplied list

    _workMapsTo = 0;
    _curSelection = -1;

    _fullList = (char**)_itemList;		// list

    // freed in gtk_list_remove_items
    //g_list_free(_workList);
    _workList = 0;

    for ( _numItems = 0 ; _fullList && _fullList[_numItems] != 0 ; ++_numItems)
      {
	GtkRequisition req;
	GtkWidget *item = gtk_list_item_new_with_label(_fullList[_numItems]);
	gtk_widget_size_request(item, &req);
	gtk_signal_connect(GTK_OBJECT(item), "button_press_event",
	    GTK_SIGNAL_FUNC(CListPressCB), (gpointer)this);
	_workList = g_list_append(_workList, item);
	gtk_widget_show(item);
/*
	if (_numItems < _listRows)	// copy only first _listRows
	  {
	    _workList[_numItems] = _fullList[_numItems];
	  }
*/

	len = strlen(_fullList[_numItems]);	// strlen
	width = gdk_text_width(item->style->font, _fullList[_numItems], len);
/*
	width = XTextWidth(theApp->_XDefaultFont,
		_fullList[_numItems], len);
*/
	if (req.width > _maxWidth)
	    _maxWidth = req.width;		// track largest so far
      }

/*
    // Note that at this point _numItems is how many items are
    // in the user supplied list. We can use this number to null
    // out the rest of the displayed list.
    if (_numItems < _listRows)
      {
	for (int ix = _numItems ; ix < _listRows ; ++ix )
	  {
	    _workList[ix] = EmptyItem;
	  }
      }

    // Now set the scrollbar size limits
    if (_numItems > _listRows)
      {
	_ScrlShown = (_listRows * 100) / _numItems;
      }
    else
	_ScrlShown = 100;

    if (_numItems > _listRows)
      {
	_fscale = 0.0;
	_scale = (100 - _ScrlShown) / (_numItems - _listRows);
	if (_scale == 0)
	  {
	    _fscale = ((100. - (float)_ScrlShown) / ((float)_numItems - (float)_listRows));
  	  }
      }
    else
	_scale = 0;		// will leave top at 0

    _ScrlTop =  0;
*/

  }

extern "C"
{
//============================>>> CListCmdCB <<<=============================
  void CListCmdCB(GtkList *list, gpointer This)
  {
    GList *dlist;
    dlist = list->selection;
    ((vListCmd*)This)->ListCmdCB(dlist ? 
	gtk_list_child_position(list, GTK_WIDGET(dlist->data))
				      : -1);
/*
    ((vListCmd*)This)->ListCmdCB(((XawListReturnStruct*)lr)->list_index);
*/
  }

//============================>>> CListPressCB <<<=============================
  void CListPressCB(GtkListItem *listitem, GdkEventButton *ev, gpointer This)
  {
    if (ev->type==GDK_2BUTTON_PRESS) {
	((vListCmd*)This)->ListCmdCB(
	    gtk_list_child_position(GTK_LIST(((vListCmd*)This)->wCmd), 
		GTK_WIDGET(listitem)));
    }
  }

/*
//============================>>> CJumpProcCB <<<=============================
  void CJumpProcCB(Widget w, XtPointer This, XtPointer pc_ptr)
  {

    float percent = *(float*)pc_ptr;	// get the percent back

    ((vListCmd*)This)->JumpProcCB((int)(percent*100.));
  }

//============================>>> CScollProcCB <<<=============================
  void CScrollProcCB(Widget w, XtPointer This, XtPointer position)
  {
    int pos = (int)position;
    ((vListCmd*)This)->ScrollProcCB(pos);
  }
*/
}
