//===============================================================
// vMenu.cxx - vMenuPane class functions - X11R5
//
// Copyright (C) 1995,1996  Bruce E. Wampler
//
// This file is part of the V C++ GUI Framework, and is covered
// under the terms of the GNU Library General Public License,
// Version 2. This library has NO WARRANTY. See the source file
// vapp.cxx for more complete information about license terms.
//===============================================================

#include <v/vmenu.h>		// our header
/*
#include <v/vctlclrs.h>
*/

extern "C"
{
#include <v/gtkvcheckmenuitem.h>
/*
#include <X11/Core.h>
#include <X11/Shell.h>

#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Xaw/Sme.h>

#define setLabel(x,y) char* x = y;
#define freeLabel(x)
#define Ncallback XtNcallback
#define Nsensitive XtNsensitive
#define Nlabel XtNlabel

*/
}

#include <v/vcmdwin.h>		// we need access to vcmdwin

#include <stdlib.h>

// Define static data of the class

/*
#define menux_width 9
#define menux_height 9
static char menux_bits[] = {
   0xff, 0x01, 0x83, 0x01, 0x45, 0x01, 0x29, 0x01, 0x11, 0x01, 0x29, 0x01,
   0x45, 0x01, 0x83, 0x01, 0xff, 0x01};
static Pixmap menux_bitmap = 0;		// the check for menus

#define menuclr_width 9
#define menuclr_height 9
static char menuclr_bits[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
static Pixmap menuclr_bitmap = 0;	// the no-check for menus

#define rtarrow_width 9
#define rtarrow_height 9
static char rtarrow_bits[] = {
   0x03, 0x00, 0x0f, 0x00, 0x3f, 0x00, 0xff, 0x00, 0xff, 0x01, 0xff, 0x00,
   0x3f, 0x00, 0x0f, 0x00, 0x03, 0x00};
static Pixmap rtarrow_bitmap = 0;	// right arrow for submenus


static void subMenuAction(Widget, XEvent *, String *, Cardinal *);
*/

/*
static XtActionsRec submenu_action = { "popupSubmenu",
     (XtActionProc)subMenuAction };
static XtTranslations   SMtrans = 0, SMtrans2 = 0;
*/

static char curLbl[100];	// for fixed labels
static char _Mnemonic;

//==================>>> vMenuPane::vMenuPane <<<===========================
  vMenuPane::vMenuPane(VCONST vMenu* menu) : vPane(P_Menu)
  {
    int i;

    // set up menus -----------------------------------------------

    SysDebug(Constructor,"vMenuPane::vMenuPane() constructor\n")

    
    _nextSubMenu =		// we will start submenus here
    _nextMenuButton = 0;	// no menus defined so far

    for (i = 0 ; i < MAX_MENU_BUTTONS ; ++i)
      {
	_mb[i].label = 0; // null out menu button array
	_mb[i].XMenuButton = 0;
	_mb[i].SubMenu = 0;
      }

    // copy the menus as defined to our array

    _info = 0;
    _menu = menu;

  }

//==================>>> vMenuPane::vMenuPane <<<===========================
  vMenuPane::vMenuPane(const vMenuPane& m) : vPane(m)
  {

    vSysError("V Semantics do not allow copy constructors.");
  }

//====================>>> vMenuPane::~vMenuPane <<<=======================
  vMenuPane::~vMenuPane()			// destructor
  {

    SysDebug(Destructor,"vMenuPane::~vMenuPane() destructor\n")

    /*
    for (int i = 0 ; i < _nextSubMenu ; ++i)	// all menus
      {
	delete _mb[i].mInfo;		// free the space
      }
    */

  }

//======================>>> vMenuPane::fixLabel <<<========================
  void vMenuPane::fixLabel(VCONST char* lbl, char* key, int isMainMenu)
  {
    // copy label to global curLbl

    VCONST char* cp;
    int ix = 0;

    _Mnemonic = 0;

#ifdef Motif
    if (!isMainMenu)
      {
	curLbl[0] = ' '; curLbl[1] = ' '; ix = 2;
      }
#endif
    for (cp = lbl ; *cp && ix < 99 ; ++cp)	// Scan label
      {
 	if (*cp != '&')
	  {
	    curLbl[ix++] = *cp;
	  }
	else
	    _Mnemonic = *(cp+1);
      }

#ifndef Motif		// ATHENA ONLY
    if (key && *key)
      {
	curLbl[ix++] = ' '; curLbl[ix++] = ' '; curLbl[ix++] = '<';
 	for (cp = key ; *cp && ix < 99 ; ++cp)
	  {
	    if (*cp != '&')
	      {
		curLbl[ix++] = *cp;
	      }
	  }
	curLbl[ix++] = '>';
      }
#endif

    curLbl[ix] = 0;		// finish off
  }

//======================>>> vMenuPane::doAddMenu <<<========================
  GtkWidget* vMenuPane::doAddMenu(vMenu *item)
  {
    GtkWidget *popup;

/*
    fixLabel(_mb[id].label,0,1);	// copy the label
    setLabel(tmp,curLbl);
*/

    popup = gtk_menu_new();

/*
    freeLabel(tmp);
*/

    // loop through the list

    /*
    _mb[id].mInfo = 0;			// empty list so far
    */

    /*
    vMenu* item = _mb[id].SubMenu;	// The first item in list
    */

    MenuInfo* info;			// for current info
    for (int ix = 0 ; item[ix].label != 0 ; ++ix)
      {
	info = new MenuInfo;		// new space or current tem
	info->NxtInfo = _info;	// add to front of list
	_info = info;		// fix front pointer
	/*
	info->ItemIndex = ix;		// index to item list
	*/
	info->item = &item[ix];		// index to item list
	info->SubMenuIndex = 0;		// no submenu normally

	if (item[ix].menuId == M_Line)
	  {
	    info->WItem = gtk_menu_item_new();
	    gtk_menu_append(GTK_MENU(popup), info->WItem);
	    gtk_widget_show(info->WItem);
	  }
	else if (item[ix].SubMenu != 0)	// a submenu
	  {
	    GtkWidget *submenu;

	    if(_nextSubMenu >= MAX_MENU_BUTTONS)
	      {
		SysDebug(BadVals,"Too many submenus!\n");
		continue;
	      }
	    fixLabel(item[ix].label);
/*
	    setLabel(tmp,curLbl);
*/

	    info->WItem = gtk_menu_item_new_with_label(curLbl);
	    gtk_menu_append(GTK_MENU(popup), info->WItem);
	    gtk_widget_show(info->WItem);

	    // we will create a submenu
	    // copy the definitions, track the new index

	    int sub = _nextSubMenu++;	// get our index, bump for next time

	    _mb[sub].label = item[ix].label;
	    _mb[sub].XMenuButton = 0;
	    _mb[sub].SubMenu = item[ix].SubMenu;
	    info->SubMenuIndex = sub;		// no submenu normally
	    // Now, recursively call doAddMenu with the submenu
	    submenu = doAddMenu(_mb[sub].SubMenu);
	    gtk_menu_item_set_submenu(GTK_MENU_ITEM(info->WItem), submenu);
	  }
	else
	  {
	    // create the item widget

	    //fixLabel(item[ix].label, item[ix].keyLabel);
	    fixLabel(item[ix].label);
	    info->WItem = gtk_v_check_menu_item_new_with_label(curLbl);
	    gtk_menu_append(GTK_MENU(popup), info->WItem);
	    gtk_widget_show(info->WItem);
	    gtk_widget_set_sensitive(GTK_WIDGET(info->WItem), item[ix].sensitive);

	    if (item[ix].checked)	// was it checked?
	      {
		//gtk_menu_item_select(GTK_MENU_ITEM(info->WItem));
		gtk_v_check_menu_item_set_state(GTK_V_CHECK_MENU_ITEM(info->WItem), TRUE);
/*
		XtVaSetValues(info->WItem,	// to this menu item
			XtNleftBitmap,		// set the left side
			menux_bitmap,		// to the X checkbox
			NULL);
*/
	      } else
	      {
		/*
		gtk_check_menu_item_set_show_toggle(
		    GTK_CHECK_MENU_ITEM(info->WItem), FALSE);
		*/
	      }


	    // and add the call back for each item
/*
	    freeLabel(tmp);

*/
#ifdef GTK_HAVE_FEATURES_1_1_0
	    if (item[ix].accel) {
		if (item[ix].accel < '@') {
		    item[ix].accel += '@';
		    item[ix].kShift |= GDK_CONTROL_MASK;
		}
		gtk_widget_add_accelerator(info->WItem, "activate",
		    theApp->GetAccelGroup(), item[ix].accel, item[ix].kShift,
		    GTK_ACCEL_VISIBLE);
	    }
#endif

	    gtk_signal_connect(GTK_OBJECT(info->WItem), "activate",
		GTK_SIGNAL_FUNC(CmenuCB), (gpointer)this);
	  }
      }
    return popup;
  }

/*
//====================>>> vMenuPane::CheckAccel <<<======================
  int vMenuPane::CheckAccel(vKey vkey, unsigned int shift, ItemVal& id)
  {
    // scan all menus in this window to see if this keystroke
    // matches an accelerator key

#ifndef Motif
    vMenu* item;

    // Search all menus in this list
    for (int ix = 0 ; ix < _nextSubMenu ; ++ix)
      {
	MenuInfo* info;			// for current info

	// scan the list of info for each menu entry

	for (info = _mb[ix].mInfo ; info != 0 ; info = info->NxtInfo)
	  {
	    item = _mb[ix].SubMenu;	// The current item in list
	    // see if its menuId is the same as the one we are setting
	    if (item[info->ItemIndex].accel == vkey
		 && item[info->ItemIndex].kShift == shift)
	      {
		id = item[info->ItemIndex].menuId;
		return 1;
	      }
	  }
      }
#endif

    id = 0;
    return 0;		// assume 0 if not found
  }
*/

//====================>>> vMenuPane::GetPaneValue <<<======================
  int vMenuPane::GetPaneValue(ItemVal id, int& val) VCONST
  {
    // scan all menus in this window to retrieve the what value
    // then scan button bar if not found

    /*
    vMenu* item;

    // Search all menus in this list
    for (int ix = 0 ; ix < _nextSubMenu ; ++ix)
      {
	MenuInfo* info;			// for current info

	// scan the list of info for each menu entry

	for (info = _mb[ix].mInfo ; info != 0 ; info = info->NxtInfo)
	  {
	    item = _mb[ix].SubMenu;	// The current item in list
	    // see if its menuId is the same as the one we are setting
	    if (item[info->ItemIndex].menuId == id)
	      {
		// Ah Ha! We found the value we want
		val = item[info->ItemIndex].checked;
		return 1;
	      }
	  }
      }
    */

    MenuInfo* info;			// for current info
    for (info = _info ; info != 0 ; info = info->NxtInfo)
      {
	// see if its menuId is the same as the one we are setting
	if (info->item->menuId == id)
	  {
	    // Ah Ha! We found the value we want
	    val = info->item->checked;
	    return 1;
	  }
      }

    val = 0;
    return 0;		// assume 0 if not found
  }

/*
//====================>>> vMenuPane::GetMenuThis <<<======================
  vMenuPane* vMenuPane::GetMenuThis(Widget w)
  {
    for (int ix = 0 ; ix < _nextSubMenu ; ++ix)
      {
	if (_mb[ix].XPopUp == w)
	    return this;
      }
    return 0;
  }
*/

//======================>>> vMenuPane::initialize <<<=======================
  void vMenuPane::initialize(vWindow* pWin, Widget pWidget,
	Widget drawCanvas, Widget drawArea)
  {
    int i;
    // First, create the Pixmaps, but only once!

    pWin->vAddMenuBar();				// Set up menubar

    vPane::initialize(pWin, pWidget);		// initialize these

    for (i = 0 ; i < MAX_MENU_BUTTONS && _menu[i].label; ++i)
      {
	_mb[i].label = _menu[i].label;
	_mb[i].SubMenu = _menu[i].SubMenu;
      }
    _nextSubMenu =		// we will start submenus here
    _nextMenuButton = i;	// this many menus defined

    // Now we have to add our menus

    for (int i = 0 ; i < _nextMenuButton ; ++i)
      {
	GtkWidget *menu, *menuitem;

	menu = doAddMenu(_mb[i].SubMenu);

	fixLabel(_mb[i].label,0,1);	// copy the label
	menuitem = gtk_menu_item_new_with_label(curLbl);
	gtk_widget_show(menuitem);
	gtk_menu_bar_append(GTK_MENU_BAR(pWidget), menuitem);
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(menuitem), menu);
      }
  }

//============================>>> vMenuPane::menuCB <<<==========================
  void vMenuPane::menuCB(Widget w)
  {
    //	menu button class callback
    //
    // We will do some work here
    // scan all menus until we find the widget

    ItemVal menu_val = 0;

    /*
    vMenu* item;

    // Scan all menus in this window looking for widget corresponding
    // to the widget that generated the callback
    for (int ix = 0 ; ix < _nextSubMenu ; ++ix)
      {
	MenuInfo* info;			// for current info

	for (info = _mb[ix].mInfo ; info != 0 ; info = info->NxtInfo)
	  {
	    if (info->WItem == w)	// found it!
	      {
		item = _mb[ix].SubMenu;	// The first item in list
		menu_val = item[info->ItemIndex].menuId;
		goto FoundIt;
	      }
	  }
      }
    */
    MenuInfo* info;			// for current info
    for (info = _info ; info != 0 ; info = info->NxtInfo)
      {
	// see if its menuId is the same as the one we are setting
	if (info->WItem == w)
	  {
	    menu_val = info->item->menuId;
	    goto FoundIt;
	  }
      }
FoundIt:
    _parentWin->MenuCommand(menu_val);
  }

extern "C"
{
//============================>>> CmenuCB <<<==========================
/*
  void CmenuCB(Widget w, XtPointer ItmPtr, XtPointer call_data)
*/
  void CmenuCB(GtkMenuItem *w, gpointer This)
  { 
    //	menu button "C" Call Back
    // ItmPtr will have the this pointer of our object

   ((vMenuPane*)This)->menuCB(GTK_WIDGET(w));
  }
}

//==================>>> vMenuPane::SetPaneValue <<<========================
  void vMenuPane::SetPaneValue(ItemVal id, int val, ItemSetType setType)
  {
    // Set the given item on or off

    /*
    vMenu* item;

    // Search all menus in this list
    for (int ix = 0 ; ix < _nextSubMenu ; ++ix)
      {
	MenuInfo* info;			// for current info

	// scan the list of info for each menu entry
	for (info = _mb[ix].mInfo ; info != 0 ; info = info->NxtInfo)
	  {
	    item = _mb[ix].SubMenu;	// The current item in list
	    // see if its menuId is the same as the one we are setting
	    if (item[info->ItemIndex].menuId == id)
	      {
		// Ah Ha! We found the value we want
		switch (setType)
		  {
		    case Value:			// check box
		    case Checked:		// check box
			item[info->ItemIndex].checked = val;
			gtk_v_check_menu_item_set_state(
			    GTK_V_CHECK_MENU_ITEM(info->WItem), val);
			break;

		    case Sensitive:			// sensitive
			item[info->ItemIndex].sensitive = val;
			gtk_widget_set_sensitive(GTK_WIDGET(info->WItem), val);
			break;
		  }	// end switch
	      }
	  }
      }
    */
    MenuInfo* info;			// for current info
    for (info = _info ; info != 0 ; info = info->NxtInfo)
      {
	// see if its menuId is the same as the one we are setting
	if (info->item->menuId == id)
	  {
	    switch (setType)
	      {
		case Value:			// check box
		case Checked:		// check box
		    info->item->checked = val;
		    gtk_v_check_menu_item_set_state(
			GTK_V_CHECK_MENU_ITEM(info->WItem), val);
		    break;

		case Sensitive:			// sensitive
		    info->item->sensitive = val;
		    gtk_widget_set_sensitive(GTK_WIDGET(info->WItem), val);
		    break;
	      }	// end switch
	  }
      }
  }

//================>>> vMenuPane::SetPaneString <<<========================
  void vMenuPane::SetPaneString(ItemVal id, VCONST char* str) 
  {
    // Set the given item on or off

    /*
    vMenu* item;

    // Search all menus in this window 
    for (int ix = 0 ; ix < _nextSubMenu ; ++ix)
      {
	MenuInfo* info;			// for current info

	// scan the list of info for each menu entry
	for (info = _mb[ix].mInfo ; info != 0 ; info = info->NxtInfo)
	  {
	    item = _mb[ix].SubMenu;	// The current item in list

	    if (item[info->ItemIndex].menuId == id)
	      {
		// Ah Ha! We found the value we want
		fixLabel(str);
		gtk_label_set(GTK_LABEL(GTK_BIN(info->WItem)->child), curLbl);
	      }
	  }
      }
    */
    MenuInfo* info;			// for current info
    for (info = _info ; info != 0 ; info = info->NxtInfo)
      {
	// see if its menuId is the same as the one we are setting
	if (info->item->menuId == id)
	  {
	    // Ah Ha! We found the value we want
	    fixLabel(str);
	    gtk_label_set(GTK_LABEL(GTK_BIN(info->WItem)->child), curLbl);
	  }
      }
  }

/*
//==================>>> vMenuPane::doSubMenu <<<========================
  void vMenuPane::doSubMenu(Widget parent, Widget subitem, int x, int y)
  {
    // Maybe popup a submenu

    // Scan all menus in this window looking for widget corresponding
    // to the widget that generated the callback
    for (int ix = 0 ; ix < _nextSubMenu ; ++ix)
      {
	if (_mb[ix].XPopUp == parent)
	  {
	    MenuInfo* info;			// for current info
	    for (info = _mb[ix].mInfo ; info != 0 ; info = info->NxtInfo)
	      {
		if (info->WItem == subitem)
		  {
		    vMenu* item = _mb[ix].SubMenu;  // The first item in list

		    // look at static definition to see if this one had a
		    // submenu. If so, then it is the one we are looking for.
		    if (item[info->ItemIndex].SubMenu != 0)
		      {
			// get the popup shell for the submenu and pop it up.
			Widget submenu = _mb[info->SubMenuIndex].XPopUp;
			XtVaSetValues(submenu, XtNx, x, XtNy, y, NULL);
			XtPopup(submenu, XtGrabExclusive);
			return;
		      }
		  }
	      }
	    break;
	  }
      }
    // we didn't find a value
  }
*/

/*
//================>>> subMenuAction <<<========================
  static void subMenuAction(Widget w, XEvent *event, 
	String *params, Cardinal *nparams)
  {
#ifndef Motif
    Dimension    width, height;
    int		x, y;
    Widget	cw = XawSimpleMenuGetActiveEntry(w);

    if (cw == 0 || event->type != MotionNotify)
	return;

    x = event->xmotion.x;
    y = event->xmotion.y;

    XtVaGetValues(w, XtNwidth, &width, XtNheight, &height, NULL);

    if (x < 0 || x >= width || y < 0 || y >= height)
	return;

    //  Only the second half of the menu is sensitve to pulls
    if (x < (width - (width / 3)))
	return;

    vMenuPane* mypane = theApp->GetMenuThis(w);

    if (mypane == 0)
	return;

    // Don't mess with this too much -- the sub menu seems to need
    // to popup over the cursor, or it loses track of things.
    x = event->xmotion.x_root - 10 ;	// Make sure cursor shows
    y = event->xmotion.y_root - 10 ;

    mypane->doSubMenu(w, cw, x, y);

#ifdef ITWORKS
    for (cur = rightHead; cur != NULL && cur->widget != cw; cur = cur->next)
	;

    if (cur == NULL)
	return;

    XtVaSetValues(cur->shell, XtNx, x, XtNy, y, NULL);

    XtPopup(cur->shell, XtGrabExclusive);
#endif
#endif
  }
*/
