#ifndef __GTK_VLAYOUT_H
#define __GTK_VLAYOUT_H

#include <gtk/gtkcontainer.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define GTK_VLAYOUT(obj)          GTK_CHECK_CAST (obj, gtk_vlayout_get_type (), GtkVLayout)
#define GTK_VLAYOUT_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_vlayout_get_type (), GtkVLayoutClass)
#define GTK_IS_VLAYOUT(obj)       GTK_CHECK_TYPE (obj, gtk_vlayout_get_type ())

typedef struct _GtkVLayout        GtkVLayout;
typedef struct _GtkVLayoutClass   GtkVLayoutClass;
typedef struct _GtkVLayoutChild   GtkVLayoutChild;

struct _GtkVLayoutChild {
  GtkWidget *widget;
  /* used for both requisition and allocation (with different meanings) */
  gint right;
  gint bottom;
  GtkVLayoutChild *left;
  GtkVLayoutChild *above;
};

struct _GtkVLayout {
  GtkContainer container;

  GList *children;
  gint16 spacing;
};

struct _GtkVLayoutClass {
  GtkContainerClass parent_class;
};

GtkWidget *	gtk_vlayout_new		(gint spacing);
guint   	gtk_vlayout_get_type    (void);
void		gtk_vlayout_add		(GtkVLayout	*vlayout, 
					 GtkWidget	*child,
					 GtkWidget	*left,
					 GtkWidget	*above);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __GTK_VLAYOUT_H */
